# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from sick_scan_xd/NAVLandmarkData.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import sick_scan_xd.msg
import std_msgs.msg

class NAVLandmarkData(genpy.Message):
  _md5sum = "6978f0aa2a911a9f94328887e912f9fb"
  _type = "sick_scan_xd/NAVLandmarkData"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """# ROS message of NAV350LandmarkData, see sick_nav_scandata_parser.h and NAV-350 telegram listing for details.
std_msgs/Header header

uint8 landmark_filter
uint16 num_reflectors
sick_scan_xd/NAVReflectorData[] reflectors

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: sick_scan_xd/NAVReflectorData
# ROS message of NAV350ReflectorData, see sick_nav_scandata_parser.h and NAV-350 telegram listing for details.

# cartesian data in lidar coordinates in mm
uint16 cartesian_data_valid
int32 x
int32 y

# polar data in lidar coordinates in mm and mdeg
uint16 polar_data_valid
uint32 dist
uint32 phi

# optional reflector data
uint16 opt_reflector_data_valid
uint16 local_id
uint16 global_id
uint8 type 
uint16 sub_type
uint16 quality
uint32 timestamp
uint16 size
uint16 hit_count
uint16 mean_echo
uint16 start_index
uint16 end_index

# reflector position in ros coordinates
int8 pos_valid   # pose_x, pose_y and pose_yaw are valid if pose_valid > 0
float32 pos_x    # x position in ros coordinates in m
float32 pos_y    # y position in ros coordinates in m
"""
  __slots__ = ['header','landmark_filter','num_reflectors','reflectors']
  _slot_types = ['std_msgs/Header','uint8','uint16','sick_scan_xd/NAVReflectorData[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,landmark_filter,num_reflectors,reflectors

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(NAVLandmarkData, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.landmark_filter is None:
        self.landmark_filter = 0
      if self.num_reflectors is None:
        self.num_reflectors = 0
      if self.reflectors is None:
        self.reflectors = []
    else:
      self.header = std_msgs.msg.Header()
      self.landmark_filter = 0
      self.num_reflectors = 0
      self.reflectors = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_BH().pack(_x.landmark_filter, _x.num_reflectors))
      length = len(self.reflectors)
      buff.write(_struct_I.pack(length))
      for val1 in self.reflectors:
        _x = val1
        buff.write(_get_struct_H2iH2I3HB2HI5Hb2f().pack(_x.cartesian_data_valid, _x.x, _x.y, _x.polar_data_valid, _x.dist, _x.phi, _x.opt_reflector_data_valid, _x.local_id, _x.global_id, _x.type, _x.sub_type, _x.quality, _x.timestamp, _x.size, _x.hit_count, _x.mean_echo, _x.start_index, _x.end_index, _x.pos_valid, _x.pos_x, _x.pos_y))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.reflectors is None:
        self.reflectors = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 3
      (_x.landmark_filter, _x.num_reflectors,) = _get_struct_BH().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.reflectors = []
      for i in range(0, length):
        val1 = sick_scan_xd.msg.NAVReflectorData()
        _x = val1
        start = end
        end += 54
        (_x.cartesian_data_valid, _x.x, _x.y, _x.polar_data_valid, _x.dist, _x.phi, _x.opt_reflector_data_valid, _x.local_id, _x.global_id, _x.type, _x.sub_type, _x.quality, _x.timestamp, _x.size, _x.hit_count, _x.mean_echo, _x.start_index, _x.end_index, _x.pos_valid, _x.pos_x, _x.pos_y,) = _get_struct_H2iH2I3HB2HI5Hb2f().unpack(str[start:end])
        self.reflectors.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_BH().pack(_x.landmark_filter, _x.num_reflectors))
      length = len(self.reflectors)
      buff.write(_struct_I.pack(length))
      for val1 in self.reflectors:
        _x = val1
        buff.write(_get_struct_H2iH2I3HB2HI5Hb2f().pack(_x.cartesian_data_valid, _x.x, _x.y, _x.polar_data_valid, _x.dist, _x.phi, _x.opt_reflector_data_valid, _x.local_id, _x.global_id, _x.type, _x.sub_type, _x.quality, _x.timestamp, _x.size, _x.hit_count, _x.mean_echo, _x.start_index, _x.end_index, _x.pos_valid, _x.pos_x, _x.pos_y))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.reflectors is None:
        self.reflectors = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 3
      (_x.landmark_filter, _x.num_reflectors,) = _get_struct_BH().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.reflectors = []
      for i in range(0, length):
        val1 = sick_scan_xd.msg.NAVReflectorData()
        _x = val1
        start = end
        end += 54
        (_x.cartesian_data_valid, _x.x, _x.y, _x.polar_data_valid, _x.dist, _x.phi, _x.opt_reflector_data_valid, _x.local_id, _x.global_id, _x.type, _x.sub_type, _x.quality, _x.timestamp, _x.size, _x.hit_count, _x.mean_echo, _x.start_index, _x.end_index, _x.pos_valid, _x.pos_x, _x.pos_y,) = _get_struct_H2iH2I3HB2HI5Hb2f().unpack(str[start:end])
        self.reflectors.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_BH = None
def _get_struct_BH():
    global _struct_BH
    if _struct_BH is None:
        _struct_BH = struct.Struct("<BH")
    return _struct_BH
_struct_H2iH2I3HB2HI5Hb2f = None
def _get_struct_H2iH2I3HB2HI5Hb2f():
    global _struct_H2iH2I3HB2HI5Hb2f
    if _struct_H2iH2I3HB2HI5Hb2f is None:
        _struct_H2iH2I3HB2HI5Hb2f = struct.Struct("<H2iH2I3HB2HI5Hb2f")
    return _struct_H2iH2I3HB2HI5Hb2f
