# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from sick_scan_xd/NAVOdomVelocity.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class NAVOdomVelocity(genpy.Message):
  _md5sum = "9ae8fb3e58991f0b8bd5ceefb3e1ca1d"
  _type = "sick_scan_xd/NAVOdomVelocity"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ROS message for NAV350 velocity/odometry data, see sick_nav_scandata_parser.h and NAV-350 telegram listing for details ("sMN mNPOSSetSpeed").

float32 vel_x # x-component of velocity in the coordinate system defined by coordbase (i.e. in lidar coordinate for coordbase=0) in m/s, -32.0 ... +32.0 m/s
float32 vel_y # y-component of velocity in the coordinate system defined by coordbase (i.e. in lidar coordinate for coordbase=0) in m/s, -32.0 ... +32.0 m/s
float32 omega # angular velocity of the NAV350 in radians/s, -2*PI ... +2*PI rad/s
uint32 timestamp # Timestamp of the Velocity vector related to the NAV350 clock
uint8 coordbase # Coordinate system of the velocity vector (local or global), 0 = local coordinate system of the NAV350, 1 = absolute coordinate system
"""
  __slots__ = ['vel_x','vel_y','omega','timestamp','coordbase']
  _slot_types = ['float32','float32','float32','uint32','uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       vel_x,vel_y,omega,timestamp,coordbase

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(NAVOdomVelocity, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.vel_x is None:
        self.vel_x = 0.
      if self.vel_y is None:
        self.vel_y = 0.
      if self.omega is None:
        self.omega = 0.
      if self.timestamp is None:
        self.timestamp = 0
      if self.coordbase is None:
        self.coordbase = 0
    else:
      self.vel_x = 0.
      self.vel_y = 0.
      self.omega = 0.
      self.timestamp = 0
      self.coordbase = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3fIB().pack(_x.vel_x, _x.vel_y, _x.omega, _x.timestamp, _x.coordbase))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 17
      (_x.vel_x, _x.vel_y, _x.omega, _x.timestamp, _x.coordbase,) = _get_struct_3fIB().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3fIB().pack(_x.vel_x, _x.vel_y, _x.omega, _x.timestamp, _x.coordbase))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 17
      (_x.vel_x, _x.vel_y, _x.omega, _x.timestamp, _x.coordbase,) = _get_struct_3fIB().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3fIB = None
def _get_struct_3fIB():
    global _struct_3fIB
    if _struct_3fIB is None:
        _struct_3fIB = struct.Struct("<3fIB")
    return _struct_3fIB
