# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from sick_scan_xd/NAVPoseData.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import std_msgs.msg

class NAVPoseData(genpy.Message):
  _md5sum = "09a85c46d8eba44e26ad07869c2bbc20"
  _type = "sick_scan_xd/NAVPoseData"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """# ROS message of NAV350PoseData, see sick_nav_scandata_parser.h and NAV-350 telegram listing for details.
std_msgs/Header header

# pose in lidar coordinates in mm and mdeg
int32 x
int32 y
uint32 phi
# optional pose data
uint16 opt_pose_data_valid
uint8 output_mode
uint32 timestamp
int32 mean_dev
uint8 nav_mode
uint32 info_state
uint8 quant_used_reflectors

# pose in ros units
int8 pose_valid   # pose_x, pose_y and pose_yaw are valid if pose_valid > 0
float32 pose_x    # x position in ros units in m
float32 pose_y    # y position in ros units in m
float32 pose_yaw  # yaw angle in radians

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id
"""
  __slots__ = ['header','x','y','phi','opt_pose_data_valid','output_mode','timestamp','mean_dev','nav_mode','info_state','quant_used_reflectors','pose_valid','pose_x','pose_y','pose_yaw']
  _slot_types = ['std_msgs/Header','int32','int32','uint32','uint16','uint8','uint32','int32','uint8','uint32','uint8','int8','float32','float32','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,x,y,phi,opt_pose_data_valid,output_mode,timestamp,mean_dev,nav_mode,info_state,quant_used_reflectors,pose_valid,pose_x,pose_y,pose_yaw

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(NAVPoseData, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.x is None:
        self.x = 0
      if self.y is None:
        self.y = 0
      if self.phi is None:
        self.phi = 0
      if self.opt_pose_data_valid is None:
        self.opt_pose_data_valid = 0
      if self.output_mode is None:
        self.output_mode = 0
      if self.timestamp is None:
        self.timestamp = 0
      if self.mean_dev is None:
        self.mean_dev = 0
      if self.nav_mode is None:
        self.nav_mode = 0
      if self.info_state is None:
        self.info_state = 0
      if self.quant_used_reflectors is None:
        self.quant_used_reflectors = 0
      if self.pose_valid is None:
        self.pose_valid = 0
      if self.pose_x is None:
        self.pose_x = 0.
      if self.pose_y is None:
        self.pose_y = 0.
      if self.pose_yaw is None:
        self.pose_yaw = 0.
    else:
      self.header = std_msgs.msg.Header()
      self.x = 0
      self.y = 0
      self.phi = 0
      self.opt_pose_data_valid = 0
      self.output_mode = 0
      self.timestamp = 0
      self.mean_dev = 0
      self.nav_mode = 0
      self.info_state = 0
      self.quant_used_reflectors = 0
      self.pose_valid = 0
      self.pose_x = 0.
      self.pose_y = 0.
      self.pose_yaw = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2iIHBIiBIBb3f().pack(_x.x, _x.y, _x.phi, _x.opt_pose_data_valid, _x.output_mode, _x.timestamp, _x.mean_dev, _x.nav_mode, _x.info_state, _x.quant_used_reflectors, _x.pose_valid, _x.pose_x, _x.pose_y, _x.pose_yaw))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 42
      (_x.x, _x.y, _x.phi, _x.opt_pose_data_valid, _x.output_mode, _x.timestamp, _x.mean_dev, _x.nav_mode, _x.info_state, _x.quant_used_reflectors, _x.pose_valid, _x.pose_x, _x.pose_y, _x.pose_yaw,) = _get_struct_2iIHBIiBIBb3f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2iIHBIiBIBb3f().pack(_x.x, _x.y, _x.phi, _x.opt_pose_data_valid, _x.output_mode, _x.timestamp, _x.mean_dev, _x.nav_mode, _x.info_state, _x.quant_used_reflectors, _x.pose_valid, _x.pose_x, _x.pose_y, _x.pose_yaw))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 42
      (_x.x, _x.y, _x.phi, _x.opt_pose_data_valid, _x.output_mode, _x.timestamp, _x.mean_dev, _x.nav_mode, _x.info_state, _x.quant_used_reflectors, _x.pose_valid, _x.pose_x, _x.pose_y, _x.pose_yaw,) = _get_struct_2iIHBIiBIBb3f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2iIHBIiBIBb3f = None
def _get_struct_2iIHBIiBIBb3f():
    global _struct_2iIHBIiBIBb3f
    if _struct_2iIHBIiBIBb3f is None:
        _struct_2iIHBIiBIBb3f = struct.Struct("<2iIHBIiBIBb3f")
    return _struct_2iIHBIiBIBb3f
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
