# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from sick_scan_xd/NAVReflectorData.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class NAVReflectorData(genpy.Message):
  _md5sum = "c834b1997d0f1a7b5b282c13153f6e67"
  _type = "sick_scan_xd/NAVReflectorData"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ROS message of NAV350ReflectorData, see sick_nav_scandata_parser.h and NAV-350 telegram listing for details.

# cartesian data in lidar coordinates in mm
uint16 cartesian_data_valid
int32 x
int32 y

# polar data in lidar coordinates in mm and mdeg
uint16 polar_data_valid
uint32 dist
uint32 phi

# optional reflector data
uint16 opt_reflector_data_valid
uint16 local_id
uint16 global_id
uint8 type 
uint16 sub_type
uint16 quality
uint32 timestamp
uint16 size
uint16 hit_count
uint16 mean_echo
uint16 start_index
uint16 end_index

# reflector position in ros coordinates
int8 pos_valid   # pose_x, pose_y and pose_yaw are valid if pose_valid > 0
float32 pos_x    # x position in ros coordinates in m
float32 pos_y    # y position in ros coordinates in m
"""
  __slots__ = ['cartesian_data_valid','x','y','polar_data_valid','dist','phi','opt_reflector_data_valid','local_id','global_id','type','sub_type','quality','timestamp','size','hit_count','mean_echo','start_index','end_index','pos_valid','pos_x','pos_y']
  _slot_types = ['uint16','int32','int32','uint16','uint32','uint32','uint16','uint16','uint16','uint8','uint16','uint16','uint32','uint16','uint16','uint16','uint16','uint16','int8','float32','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       cartesian_data_valid,x,y,polar_data_valid,dist,phi,opt_reflector_data_valid,local_id,global_id,type,sub_type,quality,timestamp,size,hit_count,mean_echo,start_index,end_index,pos_valid,pos_x,pos_y

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(NAVReflectorData, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.cartesian_data_valid is None:
        self.cartesian_data_valid = 0
      if self.x is None:
        self.x = 0
      if self.y is None:
        self.y = 0
      if self.polar_data_valid is None:
        self.polar_data_valid = 0
      if self.dist is None:
        self.dist = 0
      if self.phi is None:
        self.phi = 0
      if self.opt_reflector_data_valid is None:
        self.opt_reflector_data_valid = 0
      if self.local_id is None:
        self.local_id = 0
      if self.global_id is None:
        self.global_id = 0
      if self.type is None:
        self.type = 0
      if self.sub_type is None:
        self.sub_type = 0
      if self.quality is None:
        self.quality = 0
      if self.timestamp is None:
        self.timestamp = 0
      if self.size is None:
        self.size = 0
      if self.hit_count is None:
        self.hit_count = 0
      if self.mean_echo is None:
        self.mean_echo = 0
      if self.start_index is None:
        self.start_index = 0
      if self.end_index is None:
        self.end_index = 0
      if self.pos_valid is None:
        self.pos_valid = 0
      if self.pos_x is None:
        self.pos_x = 0.
      if self.pos_y is None:
        self.pos_y = 0.
    else:
      self.cartesian_data_valid = 0
      self.x = 0
      self.y = 0
      self.polar_data_valid = 0
      self.dist = 0
      self.phi = 0
      self.opt_reflector_data_valid = 0
      self.local_id = 0
      self.global_id = 0
      self.type = 0
      self.sub_type = 0
      self.quality = 0
      self.timestamp = 0
      self.size = 0
      self.hit_count = 0
      self.mean_echo = 0
      self.start_index = 0
      self.end_index = 0
      self.pos_valid = 0
      self.pos_x = 0.
      self.pos_y = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_H2iH2I3HB2HI5Hb2f().pack(_x.cartesian_data_valid, _x.x, _x.y, _x.polar_data_valid, _x.dist, _x.phi, _x.opt_reflector_data_valid, _x.local_id, _x.global_id, _x.type, _x.sub_type, _x.quality, _x.timestamp, _x.size, _x.hit_count, _x.mean_echo, _x.start_index, _x.end_index, _x.pos_valid, _x.pos_x, _x.pos_y))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 54
      (_x.cartesian_data_valid, _x.x, _x.y, _x.polar_data_valid, _x.dist, _x.phi, _x.opt_reflector_data_valid, _x.local_id, _x.global_id, _x.type, _x.sub_type, _x.quality, _x.timestamp, _x.size, _x.hit_count, _x.mean_echo, _x.start_index, _x.end_index, _x.pos_valid, _x.pos_x, _x.pos_y,) = _get_struct_H2iH2I3HB2HI5Hb2f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_H2iH2I3HB2HI5Hb2f().pack(_x.cartesian_data_valid, _x.x, _x.y, _x.polar_data_valid, _x.dist, _x.phi, _x.opt_reflector_data_valid, _x.local_id, _x.global_id, _x.type, _x.sub_type, _x.quality, _x.timestamp, _x.size, _x.hit_count, _x.mean_echo, _x.start_index, _x.end_index, _x.pos_valid, _x.pos_x, _x.pos_y))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 54
      (_x.cartesian_data_valid, _x.x, _x.y, _x.polar_data_valid, _x.dist, _x.phi, _x.opt_reflector_data_valid, _x.local_id, _x.global_id, _x.type, _x.sub_type, _x.quality, _x.timestamp, _x.size, _x.hit_count, _x.mean_echo, _x.start_index, _x.end_index, _x.pos_valid, _x.pos_x, _x.pos_y,) = _get_struct_H2iH2I3HB2HI5Hb2f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_H2iH2I3HB2HI5Hb2f = None
def _get_struct_H2iH2I3HB2HI5Hb2f():
    global _struct_H2iH2I3HB2HI5Hb2f
    if _struct_H2iH2I3HB2HI5Hb2f is None:
        _struct_H2iH2I3HB2HI5Hb2f = struct.Struct("<H2iH2I3HB2HI5Hb2f")
    return _struct_H2iH2I3HB2HI5Hb2f
