# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from sick_scan_xd/RadarPreHeader.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import sick_scan_xd.msg

class RadarPreHeader(genpy.Message):
  _md5sum = "93c686aba0ebefe54be53e989cc7f823"
  _type = "sick_scan_xd/RadarPreHeader"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Version information for this whole structure (MeasurementData)

uint16 uiversionno
sick_scan_xd/RadarPreHeaderDeviceBlock radarpreheaderdeviceblock
sick_scan_xd/RadarPreHeaderStatusBlock radarpreheaderstatusblock
sick_scan_xd/RadarPreHeaderMeasurementParam1Block radarpreheadermeasurementparam1block
sick_scan_xd/RadarPreHeaderEncoderBlock[] radarpreheaderarrayencoderblock

================================================================================
MSG: sick_scan_xd/RadarPreHeaderDeviceBlock
#
#
#
#

# ROS-1:
#uint32 uiIdent             # Logical number of the device"
#uint32 udiSerialNo         # Serial number of the device
#bool bDeviceError          # State of the device
#bool bContaminationWarning # Contamination Warning
#bool bContaminationError   # Contamination Error

# ROS-2:
uint32 uiident             # Logical number of the device"
uint32 udiserialno         # Serial number of the device
bool bdeviceerror          # State of the device
bool bcontaminationwarning # Contamination Warning
bool bcontaminationerror   # Contamination Error

================================================================================
MSG: sick_scan_xd/RadarPreHeaderStatusBlock
#
#
#
# ROS-1:
#uint32 uiTelegramCount # telegram number
#uint32 uiCycleCount # "scan number"
#uint32 udiSystemCountScan # system time since power on of scan gen. [us]
#uint32 udiSystemCountTransmit # system time since power on of scan transmission [us]
#uint16 uiInputs # state of digital inputs
#uint16 uiOutputs # state of digital outputs

# ROS-2:
uint32 uitelegramcount # telegram number
uint32 uicyclecount # "scan number"
uint32 udisystemcountscan # system time since power on of scan gen. [us]
uint32 udisystemcounttransmit # system time since power on of scan transmission [us]
uint16 uiinputs # state of digital inputs
uint16 uioutputs # state of digital outputs

================================================================================
MSG: sick_scan_xd/RadarPreHeaderMeasurementParam1Block
# ROS-1:
#uint32 uiCycleDuration # Time in microseconds to detect this items
#uint32 uiNoiseLevel # [1/100dB]
# ROS-2:
uint32 uicycleduration # Time in microseconds to detect this items
uint32 uinoiselevel # [1/100dB]

================================================================================
MSG: sick_scan_xd/RadarPreHeaderEncoderBlock
# Array with connected encoder sensors
# ROS-1:
#uint32 udiEncoderPos  # encoder position [inc]
#int16 iEncoderSpeed   # encoder speed [inc/mm]
# ROS-2:
uint32 udiencoderpos  # encoder position [inc]
int16 iencoderspeed   # encoder speed [inc/mm]
"""
  __slots__ = ['uiversionno','radarpreheaderdeviceblock','radarpreheaderstatusblock','radarpreheadermeasurementparam1block','radarpreheaderarrayencoderblock']
  _slot_types = ['uint16','sick_scan_xd/RadarPreHeaderDeviceBlock','sick_scan_xd/RadarPreHeaderStatusBlock','sick_scan_xd/RadarPreHeaderMeasurementParam1Block','sick_scan_xd/RadarPreHeaderEncoderBlock[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       uiversionno,radarpreheaderdeviceblock,radarpreheaderstatusblock,radarpreheadermeasurementparam1block,radarpreheaderarrayencoderblock

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(RadarPreHeader, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.uiversionno is None:
        self.uiversionno = 0
      if self.radarpreheaderdeviceblock is None:
        self.radarpreheaderdeviceblock = sick_scan_xd.msg.RadarPreHeaderDeviceBlock()
      if self.radarpreheaderstatusblock is None:
        self.radarpreheaderstatusblock = sick_scan_xd.msg.RadarPreHeaderStatusBlock()
      if self.radarpreheadermeasurementparam1block is None:
        self.radarpreheadermeasurementparam1block = sick_scan_xd.msg.RadarPreHeaderMeasurementParam1Block()
      if self.radarpreheaderarrayencoderblock is None:
        self.radarpreheaderarrayencoderblock = []
    else:
      self.uiversionno = 0
      self.radarpreheaderdeviceblock = sick_scan_xd.msg.RadarPreHeaderDeviceBlock()
      self.radarpreheaderstatusblock = sick_scan_xd.msg.RadarPreHeaderStatusBlock()
      self.radarpreheadermeasurementparam1block = sick_scan_xd.msg.RadarPreHeaderMeasurementParam1Block()
      self.radarpreheaderarrayencoderblock = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_H2I3B4I2H2I().pack(_x.uiversionno, _x.radarpreheaderdeviceblock.uiident, _x.radarpreheaderdeviceblock.udiserialno, _x.radarpreheaderdeviceblock.bdeviceerror, _x.radarpreheaderdeviceblock.bcontaminationwarning, _x.radarpreheaderdeviceblock.bcontaminationerror, _x.radarpreheaderstatusblock.uitelegramcount, _x.radarpreheaderstatusblock.uicyclecount, _x.radarpreheaderstatusblock.udisystemcountscan, _x.radarpreheaderstatusblock.udisystemcounttransmit, _x.radarpreheaderstatusblock.uiinputs, _x.radarpreheaderstatusblock.uioutputs, _x.radarpreheadermeasurementparam1block.uicycleduration, _x.radarpreheadermeasurementparam1block.uinoiselevel))
      length = len(self.radarpreheaderarrayencoderblock)
      buff.write(_struct_I.pack(length))
      for val1 in self.radarpreheaderarrayencoderblock:
        _x = val1
        buff.write(_get_struct_Ih().pack(_x.udiencoderpos, _x.iencoderspeed))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.radarpreheaderdeviceblock is None:
        self.radarpreheaderdeviceblock = sick_scan_xd.msg.RadarPreHeaderDeviceBlock()
      if self.radarpreheaderstatusblock is None:
        self.radarpreheaderstatusblock = sick_scan_xd.msg.RadarPreHeaderStatusBlock()
      if self.radarpreheadermeasurementparam1block is None:
        self.radarpreheadermeasurementparam1block = sick_scan_xd.msg.RadarPreHeaderMeasurementParam1Block()
      if self.radarpreheaderarrayencoderblock is None:
        self.radarpreheaderarrayencoderblock = None
      end = 0
      _x = self
      start = end
      end += 41
      (_x.uiversionno, _x.radarpreheaderdeviceblock.uiident, _x.radarpreheaderdeviceblock.udiserialno, _x.radarpreheaderdeviceblock.bdeviceerror, _x.radarpreheaderdeviceblock.bcontaminationwarning, _x.radarpreheaderdeviceblock.bcontaminationerror, _x.radarpreheaderstatusblock.uitelegramcount, _x.radarpreheaderstatusblock.uicyclecount, _x.radarpreheaderstatusblock.udisystemcountscan, _x.radarpreheaderstatusblock.udisystemcounttransmit, _x.radarpreheaderstatusblock.uiinputs, _x.radarpreheaderstatusblock.uioutputs, _x.radarpreheadermeasurementparam1block.uicycleduration, _x.radarpreheadermeasurementparam1block.uinoiselevel,) = _get_struct_H2I3B4I2H2I().unpack(str[start:end])
      self.radarpreheaderdeviceblock.bdeviceerror = bool(self.radarpreheaderdeviceblock.bdeviceerror)
      self.radarpreheaderdeviceblock.bcontaminationwarning = bool(self.radarpreheaderdeviceblock.bcontaminationwarning)
      self.radarpreheaderdeviceblock.bcontaminationerror = bool(self.radarpreheaderdeviceblock.bcontaminationerror)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.radarpreheaderarrayencoderblock = []
      for i in range(0, length):
        val1 = sick_scan_xd.msg.RadarPreHeaderEncoderBlock()
        _x = val1
        start = end
        end += 6
        (_x.udiencoderpos, _x.iencoderspeed,) = _get_struct_Ih().unpack(str[start:end])
        self.radarpreheaderarrayencoderblock.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_H2I3B4I2H2I().pack(_x.uiversionno, _x.radarpreheaderdeviceblock.uiident, _x.radarpreheaderdeviceblock.udiserialno, _x.radarpreheaderdeviceblock.bdeviceerror, _x.radarpreheaderdeviceblock.bcontaminationwarning, _x.radarpreheaderdeviceblock.bcontaminationerror, _x.radarpreheaderstatusblock.uitelegramcount, _x.radarpreheaderstatusblock.uicyclecount, _x.radarpreheaderstatusblock.udisystemcountscan, _x.radarpreheaderstatusblock.udisystemcounttransmit, _x.radarpreheaderstatusblock.uiinputs, _x.radarpreheaderstatusblock.uioutputs, _x.radarpreheadermeasurementparam1block.uicycleduration, _x.radarpreheadermeasurementparam1block.uinoiselevel))
      length = len(self.radarpreheaderarrayencoderblock)
      buff.write(_struct_I.pack(length))
      for val1 in self.radarpreheaderarrayencoderblock:
        _x = val1
        buff.write(_get_struct_Ih().pack(_x.udiencoderpos, _x.iencoderspeed))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.radarpreheaderdeviceblock is None:
        self.radarpreheaderdeviceblock = sick_scan_xd.msg.RadarPreHeaderDeviceBlock()
      if self.radarpreheaderstatusblock is None:
        self.radarpreheaderstatusblock = sick_scan_xd.msg.RadarPreHeaderStatusBlock()
      if self.radarpreheadermeasurementparam1block is None:
        self.radarpreheadermeasurementparam1block = sick_scan_xd.msg.RadarPreHeaderMeasurementParam1Block()
      if self.radarpreheaderarrayencoderblock is None:
        self.radarpreheaderarrayencoderblock = None
      end = 0
      _x = self
      start = end
      end += 41
      (_x.uiversionno, _x.radarpreheaderdeviceblock.uiident, _x.radarpreheaderdeviceblock.udiserialno, _x.radarpreheaderdeviceblock.bdeviceerror, _x.radarpreheaderdeviceblock.bcontaminationwarning, _x.radarpreheaderdeviceblock.bcontaminationerror, _x.radarpreheaderstatusblock.uitelegramcount, _x.radarpreheaderstatusblock.uicyclecount, _x.radarpreheaderstatusblock.udisystemcountscan, _x.radarpreheaderstatusblock.udisystemcounttransmit, _x.radarpreheaderstatusblock.uiinputs, _x.radarpreheaderstatusblock.uioutputs, _x.radarpreheadermeasurementparam1block.uicycleduration, _x.radarpreheadermeasurementparam1block.uinoiselevel,) = _get_struct_H2I3B4I2H2I().unpack(str[start:end])
      self.radarpreheaderdeviceblock.bdeviceerror = bool(self.radarpreheaderdeviceblock.bdeviceerror)
      self.radarpreheaderdeviceblock.bcontaminationwarning = bool(self.radarpreheaderdeviceblock.bcontaminationwarning)
      self.radarpreheaderdeviceblock.bcontaminationerror = bool(self.radarpreheaderdeviceblock.bcontaminationerror)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.radarpreheaderarrayencoderblock = []
      for i in range(0, length):
        val1 = sick_scan_xd.msg.RadarPreHeaderEncoderBlock()
        _x = val1
        start = end
        end += 6
        (_x.udiencoderpos, _x.iencoderspeed,) = _get_struct_Ih().unpack(str[start:end])
        self.radarpreheaderarrayencoderblock.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_H2I3B4I2H2I = None
def _get_struct_H2I3B4I2H2I():
    global _struct_H2I3B4I2H2I
    if _struct_H2I3B4I2H2I is None:
        _struct_H2I3B4I2H2I = struct.Struct("<H2I3B4I2H2I")
    return _struct_H2I3B4I2H2I
_struct_Ih = None
def _get_struct_Ih():
    global _struct_Ih
    if _struct_Ih is None:
        _struct_Ih = struct.Struct("<Ih")
    return _struct_Ih
