// Auto-generated. Do not edit!

// (in-package sick_scan_xd.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let NAVReflectorData = require('./NAVReflectorData.js');
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class NAVLandmarkData {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.landmark_filter = null;
      this.num_reflectors = null;
      this.reflectors = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('landmark_filter')) {
        this.landmark_filter = initObj.landmark_filter
      }
      else {
        this.landmark_filter = 0;
      }
      if (initObj.hasOwnProperty('num_reflectors')) {
        this.num_reflectors = initObj.num_reflectors
      }
      else {
        this.num_reflectors = 0;
      }
      if (initObj.hasOwnProperty('reflectors')) {
        this.reflectors = initObj.reflectors
      }
      else {
        this.reflectors = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type NAVLandmarkData
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [landmark_filter]
    bufferOffset = _serializer.uint8(obj.landmark_filter, buffer, bufferOffset);
    // Serialize message field [num_reflectors]
    bufferOffset = _serializer.uint16(obj.num_reflectors, buffer, bufferOffset);
    // Serialize message field [reflectors]
    // Serialize the length for message field [reflectors]
    bufferOffset = _serializer.uint32(obj.reflectors.length, buffer, bufferOffset);
    obj.reflectors.forEach((val) => {
      bufferOffset = NAVReflectorData.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type NAVLandmarkData
    let len;
    let data = new NAVLandmarkData(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [landmark_filter]
    data.landmark_filter = _deserializer.uint8(buffer, bufferOffset);
    // Deserialize message field [num_reflectors]
    data.num_reflectors = _deserializer.uint16(buffer, bufferOffset);
    // Deserialize message field [reflectors]
    // Deserialize array length for message field [reflectors]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.reflectors = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.reflectors[i] = NAVReflectorData.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    length += 54 * object.reflectors.length;
    return length + 7;
  }

  static datatype() {
    // Returns string type for a message object
    return 'sick_scan_xd/NAVLandmarkData';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '6978f0aa2a911a9f94328887e912f9fb';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ROS message of NAV350LandmarkData, see sick_nav_scandata_parser.h and NAV-350 telegram listing for details.
    std_msgs/Header header
    
    uint8 landmark_filter
    uint16 num_reflectors
    sick_scan_xd/NAVReflectorData[] reflectors
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: sick_scan_xd/NAVReflectorData
    # ROS message of NAV350ReflectorData, see sick_nav_scandata_parser.h and NAV-350 telegram listing for details.
    
    # cartesian data in lidar coordinates in mm
    uint16 cartesian_data_valid
    int32 x
    int32 y
    
    # polar data in lidar coordinates in mm and mdeg
    uint16 polar_data_valid
    uint32 dist
    uint32 phi
    
    # optional reflector data
    uint16 opt_reflector_data_valid
    uint16 local_id
    uint16 global_id
    uint8 type 
    uint16 sub_type
    uint16 quality
    uint32 timestamp
    uint16 size
    uint16 hit_count
    uint16 mean_echo
    uint16 start_index
    uint16 end_index
    
    # reflector position in ros coordinates
    int8 pos_valid   # pose_x, pose_y and pose_yaw are valid if pose_valid > 0
    float32 pos_x    # x position in ros coordinates in m
    float32 pos_y    # y position in ros coordinates in m
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new NAVLandmarkData(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.landmark_filter !== undefined) {
      resolved.landmark_filter = msg.landmark_filter;
    }
    else {
      resolved.landmark_filter = 0
    }

    if (msg.num_reflectors !== undefined) {
      resolved.num_reflectors = msg.num_reflectors;
    }
    else {
      resolved.num_reflectors = 0
    }

    if (msg.reflectors !== undefined) {
      resolved.reflectors = new Array(msg.reflectors.length);
      for (let i = 0; i < resolved.reflectors.length; ++i) {
        resolved.reflectors[i] = NAVReflectorData.Resolve(msg.reflectors[i]);
      }
    }
    else {
      resolved.reflectors = []
    }

    return resolved;
    }
};

module.exports = NAVLandmarkData;
